'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var _marked = [getOverrides].map(regeneratorRuntime.mark);

var REQUIRE_PATTERN = /^~\//;

function testPattern(value, pattern) {
  var type = typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern);

  if (type !== 'undefined' && type !== 'string') {
    throw Error('Invalid require prefix pattern.');
  }

  var regexp = type === 'string' ? new RegExp(pattern) : REQUIRE_PATTERN;

  if (!regexp.test(value)) {
    return false;
  }

  return value.replace(regexp, '');
}

function resolveAbsolute(filename) {
  filename = _path2.default.normalize(filename);
  if (_path2.default.isAbsolute(filename)) {
    return filename;
  }

  if (process.env.PWD) {
    return _path2.default.resolve(process.env.PWD, filename);
  }

  return _path2.default.resolve(filename);
}

function makeRelative(basePath, modulePath) {
  var relativePath = _path2.default.relative(basePath, modulePath);

  if (!relativePath.startsWith('.')) {
    relativePath = _path2.default.join('./', relativePath);
  }

  return relativePath;
}

function getOverrides(currentPath, projectPath, overrides) {
  var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, override, pathPrefix;

  return regeneratorRuntime.wrap(function getOverrides$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context.prev = 3;
          _iterator = overrides[Symbol.iterator]();

        case 5:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context.next = 14;
            break;
          }

          override = _step.value;
          pathPrefix = _path2.default.join(projectPath, override);

          if (!(typeof override === 'string' && currentPath.startsWith(pathPrefix))) {
            _context.next = 11;
            break;
          }

          _context.next = 11;
          return override;

        case 11:
          _iteratorNormalCompletion = true;
          _context.next = 5;
          break;

        case 14:
          _context.next = 20;
          break;

        case 16:
          _context.prev = 16;
          _context.t0 = _context['catch'](3);
          _didIteratorError = true;
          _iteratorError = _context.t0;

        case 20:
          _context.prev = 20;
          _context.prev = 21;

          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }

        case 23:
          _context.prev = 23;

          if (!_didIteratorError) {
            _context.next = 26;
            break;
          }

          throw _iteratorError;

        case 26:
          return _context.finish(23);

        case 27:
          return _context.finish(20);

        case 28:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this, [[3, 16, 20, 28], [21,, 23, 27]]);
}

function getBasePath(currentPath, projectPath, options) {
  var _options$overrides = options.overrides;
  var overrides = _options$overrides === undefined ? [] : _options$overrides;
  var _options$basePath = options.basePath;
  var basePath = _options$basePath === undefined ? '' : _options$basePath;

  var matches = [].concat(_toConsumableArray(getOverrides(currentPath, projectPath, overrides)));

  return resolveAbsolute(matches.pop() || basePath);
}

function makeModulePathRelative(currentFile, node, options) {
  var requirePath = testPattern(node.value, options.pattern);

  if (requirePath) {
    var currentPath = resolveAbsolute(_path2.default.dirname(currentFile));
    var rootPath = resolveAbsolute('.');
    var basePath = getBasePath(currentPath, rootPath, options);

    node.value = makeRelative(currentPath, resolveAbsolute(_path2.default.join(basePath, requirePath)));
  }
}

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      CallExpression: {
        exit: function exit(_ref2, state) {
          var node = _ref2.node;

          if (!t.isIdentifier(node.callee, { name: 'require' }) && !(t.isMemberExpression(node.callee) && t.isIdentifier(node.callee.object, { name: 'require' }))) {
            return;
          }

          var currentFile = state.file.opts.filename;
          var moduleNode = node.arguments[0];

          if (t.isStringLiteral(moduleNode)) {
            makeModulePathRelative(currentFile, moduleNode, state.opts);
          }
        }
      },
      ImportDeclaration: {
        exit: function exit(_ref3, state) {
          var node = _ref3.node;

          var currentFile = state.file.opts.filename;
          var moduleNode = node.source;

          if (t.isStringLiteral(moduleNode)) {
            makeModulePathRelative(currentFile, moduleNode, state.opts);
          }
        }
      }
    }
  };
};